<?php

class TagTranslator
{
 










 function translate( $tag, $content, $closer, $subject, $start, $end ) {}
}














function parse_tags( $subject, $openingTags, $closingTags, &$translator, $start=0, $closer="", $depth=0, $lowersubject=false )
{
 global $DEBUG;

 if ( $lowersubject === false )
 $lowersubject = strtolower($subject);
 
 if ( $DEBUG["parse_tags"] ) {
 echo "subject: ".htmlentities_utf8($subject)."<br>start: $start<br>closer: ".htmlentities_utf8($closer)."<br>depth: $depth<br>";
 }
 $time = time();
 $ret = "";
 $subjectLength = strlen( $subject );
 do
 {
 if ( $start >= $subjectLength )
 {
 if ( $depth > 0 )
 {
 if ( $DEBUG["parse_tags"] ) {
 echo "returning; warning: no opener/closer found in depth > 0!<br /><br />";
 }
 $return = array( "content" => "",
 "closer" => null,
 "endpos" => $subjectLength-1 );
 return $return;
 }
 if ( $DEBUG["parse_tags"] ) {
 echo "returning at end: ".htmlentities_utf8($ret)."<br />-----------------------<br /><br />";
 }
 return $ret;
 }
 
 $firstOpener = "";
 $firstOpenerPos = -1;
 foreach ( $openingTags as $key=>$oTag )
 {
 $openPos = strpos( $lowersubject, $oTag, $start );
 if ( $openPos !== false )
 {
 if ( $openPos < $firstOpenerPos || $firstOpenerPos < 0 )
 {
 $firstOpenerPos = $openPos;
 $firstOpener = $key; 
 }
 }
 }
 
 if ( $closer )
 $closerPos = strpos( $lowersubject, $closer, $start );
 else
 $closerPos = -1;

 if ( $DEBUG["parse_tags"] ) {
 echo "found opener '".htmlentities_utf8($openingTags[$firstOpener])."' at pos $firstOpenerPos<br>";
 echo "found closer '".htmlentities_utf8($closer)."' at pos $closerPos<br>";
 }

 
 
 if ( $closerPos > -1 && ( $firstOpenerPos > $closerPos || $firstOpenerPos < 0 ) )
 {
 decho( "parse_tags: if/1", "parse_tags" );
 $closerEndPos = get_tag_end( $subject, $closerPos+1 );
 if ( $closerEndPos < 0 ) $closerEndPos = $subjectLength; 
 $retCloser = substr( $subject, $closerPos, $closerEndPos-$closerPos+1 );
 
 $return = array( "content" => $ret . substr( $subject, $start, $closerPos-$start ),
 "closer" => $retCloser,
 "endpos" => $closerEndPos );
 if ( $DEBUG["parse_tags"] ) {
 echo "returning: content: ".htmlentities_utf8($return["content"]).", closer: ".
 htmlentities_utf8($return["closer"]).", endpos $return[endpos]<br>";
 echo "------------------------------<br /><br />";
 }
 return $return;
 }
 
 
 
 if ( $firstOpenerPos >= 0 )
 {
 decho( "parse_tags: if/2", "parse_tags" );
 $ret .= substr( $subject, $start, $firstOpenerPos-$start );
 
 $firstOpenerEndPos = get_tag_end( $subject, $firstOpenerPos+1 );
 if ( $firstOpenerEndPos < 0 )
 {
 decho( "parse_tags: if/3", "parse_tags" );
 if ( $DEBUG["parse_tags"] ) {
 echo "returning false: firstOpenerEndPos < 0!<br><br>";
 }
 return false;
 }
 $tag = substr( $subject, $firstOpenerPos, $firstOpenerEndPos-$firstOpenerPos+1 );
 
 if ( $closingTags[$firstOpener] !== null )
 {
 decho( "parse_tags: if/4", "parse_tags" );
 $sub = parse_tags( $subject, $openingTags, $closingTags, $translator, $firstOpenerEndPos+1, 
 $closingTags[$firstOpener], $depth+1, $lowersubject );
 if ( $sub === false )
 {
 if ( $DEBUG["parse_tags"] ) {
 echo "returning false: no fully qualified tags found!<br>";
 }
 return false;
 }
 $start = $sub["endpos"]+1;
 $ret .= $translator->translate( $tag, $sub["content"], $sub["closer"], $subject, 
 $firstOpenerPos, $sub["endpos"] );
 }
 else
 {
 decho( "parse_tags: else/1", "parse_tags" );
 $ret .= $translator->translate( $tag, "", null, $subject, 
 $firstOpenerPos, $firstOpenerEndPos );
 $start = $firstOpenerEndPos+1;
 }
 }
 else if ( $depth > 0 )
 {
 decho( "parse_tags: elseif/1", "parse_tags" );
 if ( $DEBUG["parse_tags"] ) {
 echo "returning: warning: no opener/closer found in depth > 0!<br /><br />";
 }
 $return = array( "content" => $ret . substr( $subject, $start ),
 "closer" => null,
 "endpos" => $subjectLength-1 );
 return $return;
 }
 else
 {
 decho( "parse_tags: else/2", "parse_tags" );
 $return = $ret . substr( $subject, $start );
 if ( $DEBUG["parse_tags"] ) {
 echo "returning at end: ".htmlentities_utf8($return)."<br><br>";
 }
 return $return;
 }
 } while ( TRUE );
}



?>