<? 



































class BrowserDetection extends BaseObject {

 var $userAgent;
 var $browserInfo;
 
 var $browserTypes;
 var $mozTypes;
 var $osStrings;
 var $browserStrings;
 var $browserPlatform;

 var $found;
 
 function BrowserDetection( $userAgent = false ) {
 $this->setUserAgent($userAgent);
 $this->_initialize();
 $this->_browserDetection();
 }
 
 function setUserAgent( $userAgent = false ) {
 $this->userAgent = $userAgent===false?$_SERVER['HTTP_USER_AGENT']:$userAgent;
 $this->browserInfo = array();
 $this->found = false;
 }
 
 function getUserAgent() {
 return $this->userAgent;
 }
 
 function toString() {
 return $this->getUserAgent();
 }

 function getProperties() {
 return array_keys($this->browserInfo);
 }
 
 function getProperty($property) {
 return (isset($this->browserInfo[$property]))?new StringObject($this->browserInfo[$property]):NULL;
 }

 function getBrowserInfo($property, $default = NULL) {
 return (isset($this->browserInfo[$property]))?$this->browserInfo[$property]:$default;
 }

 function getBrowserInfos() {
 return $this->browserInfos();
 }
 
 






 function detectBrowser($mode = "auto") {
 
 $success = false;
 
 if ($mode == "full" || $mode == "ini" || ($mode == "auto" && !$success)) {
 $success = $this->_readBrowscapFile() || $success;
 }
 if ($mode == "full" || $mode == "match" || ($mode == "auto" && !$success)) {
 $success = $this->_matchBrowserAgent() || $success;
 }
 if ($mode == "full" || $mode == "parse" || ($mode == "auto" && !$success)) {
 $success = $this->_browserDetection() || $success;
 }
 
 return $success;
 }

 function getBrowserInfoHtml($advanced = false) {

 $out = "<table cellspacing=1 cellpadding=0 border=0>\n";
 
 if (($val = $this->browserInfo["name"]) !== NULL) $out .= "<tr><td>Browser</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["major_version"]) !== NULL) $out .= "<tr><td>Major Version</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["minor_version"]) !== NULL) $out .= "<tr><td>Minor Version</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["crawler"]) !== NULL) $out .= "<tr><td>Crawler</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["platform"]) !== NULL) $out .= "<tr><td>Platform</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["platform_name"]) !== NULL) $out .= "<tr><td>Platform Name</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["platform_number"]) !== NULL) $out .= "<tr><td>Platform Number</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["dom_capable"]) !== NULL) $out .= "<tr><td>DOM Capable</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["safe_browser"]) !== NULL) $out .= "<tr><td>Safe Browser</td><td>$val</td></tr>\n";
 if ($advanced) {
 if (($val = $this->browserInfo["parent"]) !== NULL) $out .= "<tr><td>Parent</td><td>$val</td></tr>\n";
 if (($val = $this->browserInfo["match"]) !== NULL) $out .= "<tr><td>Match</td><td>$val</td></tr>\n";
 $out .= "<tr><td>Agent</td><td>".$this->userAgent."</td></tr>";
 }
 
 $out .= "</table>";
 
 return $out;
 }
 
 
 
 
 function _initialize() {
 










 $a_browser_types[] = array( 'opera', true, 'op', 'Opera', 0 );
 $a_browser_types[] = array( 'msie', true, 'ie', 'Internet Explorer', 0 );
 $a_browser_types[] = array( 'Trident', true, 'ie', 'Internet Explorer', 0);
 $a_browser_types[] = array( 'konqueror', true, 'konq', 'Konqueror', 0 );
 $a_browser_types[] = array( 'safari', true, 'saf', 'Safari', 0 );
 
 $a_browser_types[] = array( 'gecko', true, 'moz', 'Mozilla', 0 );
 
 $a_browser_types[] = array( 'mozilla/4', false, 'ns4', 'Netscape', 0 );
 $a_browser_types[] = array( 'lynx', false, 'lynx', 'Lynx', 0 );
 $a_browser_types[] = array( 'webtv', false, 'webtv', 'WebTV', 0 );
 
 $a_browser_types[] = array( 'googlebot', false, 'google', 'Googlebot', 1 );
 $a_browser_types[] = array( 'yahoo-verticalcrawler', false, 'yahoo', 'Yahoo Bot (old)', 1 );
 $a_browser_types[] = array( 'yahoo! slurp', false, 'yahoo', 'Yahoo Bot', 1 ); 
 $a_browser_types[] = array( 'fast-webcrawler', false, 'fast', 'Fast-Webcrawler', 1 );
 $a_browser_types[] = array( 'msnbot', false, 'msn', 'MSN Search Bot', 1 );
 $a_browser_types[] = array( 'ask jeeves', false, 'ask', 'Ask jeeves', 1 ); 
 $a_browser_types[] = array( 'teoma', false, 'ask', 'Ask Jeeves Teoma', 1 );
 $a_browser_types[] = array( 'scooter', false, 'scooter', 'Altavista Scooter', 1 );
 $a_browser_types[] = array( 'zyborg', false, 'looksmart', 'Zyborg', 1 );
 $a_browser_types[] = array( 'almaden', false, 'ibm', 'IBM Almaden Web Crawler', 1 );
 

 




 $moz_types = array( 'firebird', 'phoenix', 'firefox', 'galeon', 'k-meleon', 'camino', 'epiphany', 
 'netscape6', 'netscape', 'multizilla', 'rv' );

 $this->browserTypes = $a_browser_types;
 $this->mozTypes = $moz_types;

 
 $this->browserStrings = array("Konqueror(/([0-9]+)\.([0-9]+))?"=>"Konqueror",
 "Opera(/([0-9]+)\.([0-9]+))?"=>"Opera","Opera( ([0-9]+)\.([0-9]+))?"=>"Opera",
 "Galeon(/([0-9]+)\.([0-9]+))?"=>"Galeon","MSIE( ([0-9]+)\.([0-9]+))?"=>"Internet Explorer",
 "Trident/[0-9]+)\.([0-9]+)" => "Internet Explorer",
 "Lynx(/([0-9]+)\.([0-9]+))?"=>"Lynx",
 "libwww(-([0-9]+)\.([0-9]+))?"=>"Lynx","WebWasher( ([0-9]+)\.([0-9]+))?"=>"WebWasher",
 "SpaceBison(/([0-9]+)\.([0-9]+))?"=>"SpaceBison", "IBrowse(/([0-9]+)\.([0-9]+))?"=>"IBrowse");
 
 $this->osStrings = array("Windows 95","Windows 98","Windows 2000","Windows NT 4.0","Windows XP","Linux","Amiga","SunOS 5.8","BeOS","Windows NT 5.0"=>"Windows 2000", "Windows NT 5.1"=>"Windows XP", "Windows ME", "AmigaOS V45", "AmigaOS 3.5", "AmigaOS");
 $this->browserPlatform = array("WebWasher"=>"Unknown","SpaceBison"=>"Unknown");
 
 }
 
 function _readBrowscapFile() {
 global $MATCH, $BROWSCAP_INIFILE;
 $k = read_ini_section($BROWSCAP_INIFILE,$this->userAgent,true,true,"parent");
 
 if ($k["browser"]) {
 switch ($k["platform"]) {
 case "Win95": $platform = "Windows 95"; break;
 case "Win98": $platform = "Windows 98"; break;
 case "WinNT": $platform = "Windows NT"; break;
 case "Windows95": $platform = "Windows 95"; break;
 case "Win2000": $platform = "Windows 2000"; break;
 case "WinXP": $platform = "Windows XP"; break;
 default: $platform = $k["platform"];
 }
 if ($k["browser"] == "IE") $k["browser"] = "Internet Explorer";
 
 $this->browserInfo["name"] = $k["browser"];
 $this->browserInfo["parent"] = $k["parent"];
 $this->browserInfo["major_version"] = (ereg("#?([0-9]*)",$k["majorver"],$r1))?$r1[1]:$k["majorver"];
 $this->browserInfo["minor_version"] = (ereg("#?([0-9]*)",$k["minorver"],$r1))?$r1[1]:$k["minorver"];
 $this->browserInfo["platform"] = $platform;
 $this->browserInfo["crawler"] = (!$k["crawler"] || strtolower($k["crawler"]) == "false")?0:1;
 $this->browserInfo["match"] = $MATCH[1];
 $success = true;
 } else {
 $success = false;
 }
 return $success;
 }

 function _matchBrowserAgent() {
 
 $found = false;
 $v = $this->userAgent;
 
 reset($this->browserStrings);
 while(list($key,$val) = each($this->browserStrings)) {
 if (ereg($key,$v,$regs)) {
 $this->browserInfo["name"] = $val;
 $this->browserInfo["major_version"] = $regs[2];
 $this->browserInfo["minor_version"] = $regs[3];
 if ($regs[2]) { $found = true; break; }
 }
 }
 
 reset($this->osStrings);
 while (list($key,$val) = each($this->osStrings)) {
 if (is_numeric($key)) $key = $val;
 if (ereg($key,$v,$regs)) {
 $this->browserInfo["platform"] = $val;
 break;
 }
 }

 if (!$this->browserInfo["platform"] && $this->browserPlatform[$name]) 
 $this->browserInfo["platform"] = $this->browserPlatform[$name];

 if (!$this->browserInfo["name"] && !$this->browserInfo["platform"]) {
 if (!isset($this->browserInfo["name"])) $this->browserInfo["name"] = "Unknown ($v)";
 $found = false;
 } else {
 $this->browserInfo["match"] = $v;
 }

 return $found;
 }
 
 function _browserDetection() {

 
 $dom_browser = false;
 $safe_browser = false;
 $os = '';
 $os_number = '';
 $a_os_data = '';
 $browser_name = '';
 $version_number = '';
 $ie_version = '';
 $moz_version = '';
 $moz_version_number = '';
 $moz_rv = '';
 $moz_rv_full = '';
 $moz_release = '';
 $b_success = false;

 
 $browser_user_agent = strtolower( $this->userAgent );
 
 



 for ($i = 0; $i < count($this->browserTypes); $i++)
 {
 
 $s_browser = $this->browserTypes[$i][0];

 if (stristr($browser_user_agent, $s_browser)) 
 {
 
 
 
 $safe_browser = true;

 
 $dom_browser = $this->browserTypes[$i][1];
 $browser_name = $this->browserTypes[$i][2];
 $friendly_name = $this->browserTypes[$i][3];
 $crawler = $this->browserTypes[$i][4];

 switch ( $browser_name )
 {
 case 'ns4':
 $safe_browser = false;
 
 
 $version_number = '4.' . $this->_browserVersion( $browser_user_agent, $s_browser );
 break;
 case 'moz':
 







 
 $moz_rv_full = $this->_browserVersion( $browser_user_agent, 'rv' );
 
 $moz_rv = substr( $moz_rv_full, 0, 3 );

 
 for ( $i = 0; $i < count( $this->mozTypes ); $i++ )
 {
 if ( stristr( $browser_user_agent, $this->mozTypes[$i] ) ) 
 {
 $moz_version = $this->mozTypes[$i];
 $moz_version_number = $this->_browserVersion( $browser_user_agent, $moz_version );
 break;
 }
 }
 
 
 if ( !$moz_rv ) 
 { 
 $moz_rv = substr( $moz_version_number, 0, 3 ); 
 $moz_rv_full = $moz_version_number; 
 




 }
 
 if ( $moz_version == 'rv' ) 
 {
 $moz_version = 'mozilla';
 }
 
 
 $version_number = $moz_rv;
 
 $moz_release = $this->_browserVersion( $browser_user_agent, 'gecko/' );
 




 if ( ( $moz_release < 20020400 ) || ( $moz_rv < 1 ) )
 {
 $safe_browser = false;
 }
 break;
 case 'ie':
 $version_number = $this->_browserVersion( $browser_user_agent, $s_browser );
 if ( stristr( $browser_user_agent, 'mac') )
 {
 $ie_version = 'ieMac';
 }
 
 if ( $version_number >= 5 )
 {
 $ie_version = 'ie5x';
 }
 elseif ( ( $version_number > 3 ) && ( $version_number < 5 ) )
 {
 $dom_browser = false;
 $ie_version = 'ie4';
 
 $safe_browser = true; 
 }
 else
 {
 $ie_version = 'old';
 $dom_browser = false;
 $safe_browser = false; 
 }
 break;
 case 'op':
 $version_number = $this->_browserVersion( $browser_user_agent, $s_browser );
 if ( $version_number < 5 )
 {
 $safe_browser = false; 
 }
 break;
 case 'saf':
 $version_number = $this->_browserVersion( $browser_user_agent, $s_browser );
 break;
 default:
 $version_number = $this->_browserVersion( $browser_user_agent, $s_browser );
 break;
 }
 
 $b_success = true;
 break;
 }
 }
 
 
 if ( !$b_success ) 
 {
 





 $s_browser = substr( $browser_user_agent, 0, strcspn( $browser_user_agent , '();') );
 
 }
 
 if ($b_success) {
 
 $a_os_data = $this->_whichOs( $browser_user_agent, $browser_name, $version_number );
 $os = $a_os_data[0];
 $os_number = $a_os_data[1];
 }

 if ($version_number != "") {
 if (ereg("([0-9]+).([0-9a-zA-Z]+)",$version_number, $regs)) {
 $major_version = $regs[1];
 $minor_version = $regs[2];
 } else {
 $major_version = $version_number;
 }
 }
 
 if (isset($friendly_name)) $this->browserInfo["name"] = $friendly_name;
 if (isset($major_version)) $this->browserInfo["major_version"] = $major_version;
 if (isset($minor_version)) $this->browserInfo["minor_version"] = $minor_version;
 if (isset($os)) $this->browserInfo["platform_name"] = $os;
 if (isset($os_number)) $this->browserInfo["platform_number"] = $os_number;
 if (isset($os)) $this->browserInfo["platform"] = $this->_prettyOs( $os, $os_number );
 if (isset($crawler)) $this->browserInfo["crawler"] = $crawler?1:0;
 if (isset($dom_browser)) $this->browserInfo["dom_capable"] = $dom_browser;
 if (isset($safe_browser)) $this->browserInfo["safe_browser"] = $safe_browser;
 
 return $b_success;
 }

 
 function _prettyOs( $os, $os_number ) {
 $platform = "";
 switch ($os) {
 case "win": $platform = "Windows $os_number"; break;
 case "nt": if ($os_number < 5) $platform = "Windows NT $os_number";
 else if ($os_number == 5.0) $platform = "Windows 2000";
 else if ($os_number == 5.1) $platform = "Windows XP";
 break;
 case "mac": $platform = "Mac OS $os_number"; break;
 case "lin": $platform = "Linux $os_number"; break;
 case "unix": $platform = "Unix $os_number"; break;
 default: $platform = $os; if ($os_number) $platform .= " $os_number"; break;
 }
 return $platform;
 }

 
 function _whichOs ( $browser_string, $browser_name, $version_number )
 {
 
 $os = '';
 $os_version = '';
 




 $a_mac = array( 'mac68k', 'macppc' );
 
 $a_unix = array( 'Unixware', 'Solaris', 'SunOS', 'Sun4', 'sun5', 'Suni86', 'Sun', 
 'FreeBSD', 'OpenBSD', 'BSD' , 'Irix5', 'Irix6', 'Irix', 'HPux9', 'HPux10', 'HPux11', 'HPux', 'HP-ux', 
 'Aix1', 'Aix2', 'Aix3', 'Aix4', 'Aix5', 'Aix', 'SCO', 'Unixware', 'mpras', 'Reliant',
 'DEC', 'sinix', 'unix' );
 
 $a_linux = array( 'Debian', 'Suse', 'Redhat', 'Slackware', 'Mandrake', 'Gentoo', 'lin' );
 $a_linux_process = array ( 'i386', 'i586', 'i686' );
 $a_os = array( 'mac', 'nt', 'win', 'os2', $a_unix, $a_linux );

 
 for ( $i = 0; $i < count( $a_os ); $i++ )
 {
 
 $s_os = $a_os[$i];

 
 if ( !is_array( $s_os ) && stristr( $browser_string, $s_os ) )
 {
 $os = $s_os;

 switch ( $os )
 {
 case 'win':
 if ( strstr( $browser_string, '95' ) )
 {
 $os_version = '95';
 }
 elseif ( strstr( $browser_string, '98' ) )
 {
 $os_version = '98';
 }
 elseif ( strstr( $browser_string, 'me' ) )
 {
 $os_version = 'me';
 }
 elseif ( strstr( $browser_string, '2000' ) )
 {
 $os_version = 5.0;
 $os = 'nt';
 }
 elseif ( strstr( $browser_string, 'xp' ) )
 {
 $os_version = 5.1;
 $os = 'nt';
 }
 break;
 case 'nt':
 if ( strstr( $browser_string, 'nt 5.1' ) || strstr( $browser_string, 'xp' ) )
 {
 $os_version = 5.1;
 }
 elseif ( strstr( $browser_string, 'nt 5' ) || strstr( $browser_string, '2000' ) )
 {
 $os_version = 5.0;
 }
 elseif ( strstr( $browser_string, 'nt 4' ) )
 {
 $os_version = 4;
 }
 elseif ( strstr( $browser_string, 'nt 3' ) )
 {
 $os_version = 3;
 }
 break;
 case 'mac':
 if ( strstr( $browser_string, 'os x' ) ) 
 {
 $os_version = 10;
 }
 
 
 elseif ( ( $browser_name == 'saf' ) || ( $browser_name == 'cam' ) || 
 ( ( $browser_name == 'moz' ) && ( $version_number >= 1.3 ) ) || 
 ( ( $browser_name == 'ie' ) && ( $version_number >= 5.2 ) ) )
 {
 $os_version = 10;
 }
 break;
 default:
 break;
 }
 break;
 }
 
 elseif ( is_array( $s_os ) && ( $i == ( count( $a_os ) - 2 ) ) )
 {
 for ($j = 0; $j < count($s_os); $j++)
 {
 if ( stristr( $browser_string, $s_os[$j] ) )
 {
 $os = 'unix'; 
 $os_version = ( $s_os[$j] != 'unix' ) ? $s_os[$j] : '';
 break;
 }
 }
 } 
 elseif ( is_array( $s_os ) && ( $i == ( count( $a_os ) - 1 ) ) )
 {
 for ($j = 0; $j < count($s_os); $j++)
 {
 if ( stristr( $browser_string, $s_os[$j] ) )
 {
 $os = 'lin';
 
 
 $os_version = ( $s_os[$j] != 'lin' ) ? $s_os[$j] : '';
 break;
 }
 }
 } 
 }

 
 $os_data = array( $os, $os_version );
 return $os_data;
 }

 
 
 function _browserVersion( $browser_user_agent, $search_string )
 {
 
 $substring_length = 8;
 
 $browser_number = '';

 
 
 
 $start_pos = 0; 
 


 
 for ( $i = 0; $i < 4; $i++ )
 {
 
 if ( strpos( $browser_user_agent, $search_string, $start_pos ) !== false )
 {
 
 $start_pos = strpos( $browser_user_agent, $search_string, $start_pos ) + strlen( $search_string );
 if ( $search_string != 'msie' )
 {
 break;
 }
 }
 else 
 {
 break;
 }
 }

 
 if ( $search_string != 'gecko/' ) 
 { 
 $start_pos++; 
 }

 
 $browser_number = substr( $browser_user_agent, $start_pos, $substring_length );

 
 $browser_number = substr( $browser_number, 0, strcspn($browser_number, ' );') );

 
 
 if ( !is_numeric( substr( $browser_number, 0, 1 ) ) )
 { 
 $browser_number = ''; 
 }
 
 return $browser_number;
 }
}






?>
