<?



function getUnusedContentTagIds($item_id, $page_id) {
 node_class("CNPageObject");
 $parser = new CodeParser(new CNPageObject($page_id), false, true, CN_EM_PREVIEW, false);
 $source = $parser->renderTagIds();
 if (preg_match("/content tag ids: \[([0-9, ]+)\].*/", $source, $matches)) {
 
 $usedTagIds = explode(",", $matches[1]); 
 while (list($id, $v) = each($item_id)) {
 if (!in_array($id, $usedTagIds)) {
 $deleteTagIds[] = $id;
 }
 }
 if (count($deleteTagIds) > 0) {
 return $deleteTagIds;
 }
 }
 return false;
}






 
function cleanup_page_tags($page_id, $mode = null, $affectedTags = null) {
 global $PAGE_ID, $FOUND_TAGS, $T_PAGE, $DEBUG, $FEATURE;

 if (!$FEATURE["page_cleanup_36"]) return;
 
 $PAGE_ID = $page_id;
 $FOUND_TAGS = array();

 objtranslatecache_clear($page_id, $T_PAGE);
 
 $page = get_page_source($page_id);
 $source = $page["source"];
 
 $tags = translate_pagecontent($page_id);
 $source = code_translate($source,$tags,"page",false,Array(),$T_PAGE,$PAGE_ID);

 $unused = find_unused_tags($page_id, $FOUND_TAGS);
 
 if (count($unused)) {
 $sql = "UPDATE contenttag SET unused = 1 WHERE id IN (".implode(",", sqlf_tl_num_array($unused)).")";
 $rs = query($sql);
 
 decho("Found ".count($unused)." unused tags, changed ".$rs["num"], "cleanup_tags");
 } else {
 decho("No unused tags found.", "cleanup_tags");
 }

 if ($mode == "reset") {
 $sql = "UPDATE contenttag, page SET contenttag.unused = 0 WHERE contenttag.content_id = page.content_id AND page.id = ".sqlf_tl_num($page_id);
 if (count($unused)) {
 $sql .= " AND contenttag.id NOT IN (".implode(",", sqlf_tl_num_array($unused)).")";
 }
 $rs = query($sql);
 decho("Resetted ".$rs["num"]." used tags.", "cleanup_tags");
 } else if ($mode == "del") {
 foreach($unused as $tag) {
 
 if ($affectedTags == null || $affectedTags[$tag]) {
 tag_del($tag,"content");
 }
 }
 }

 $FOUND_TAGS = false;
 
}

function try_reuse_tag($tag_id, $tagbase, $reenable = true, $edit = false, $node_id = 0, $page_id = 0) {

 if (!$tag_id) return false;
 
 
 if (!$page_id) {
 $sql = "SELECT page.id FROM page, folder, contenttag WHERE contenttag.content_id = page.content_id AND page.folder_id = folder.id AND contenttag.id = ".sqlf_tl_num($tag_id);
 
 if ($node_id) {
 $sql .= " AND folder.node_id = ".sqlf_tl_num($node_id);
 }
 $rs = query($sql);
 $page_id = $rs["arr"][0]["id"];
 }

 if ($page_id) {

 $note = "";
 
 if ($reenable) {
 $sql = "UPDATE contenttag SET unused = 0 WHERE id = ".sqlf_tl_num($tag_id);
 $rs = query($sql);
 $note = $rs["num"]?"reused":"not reused";
 }
 
 decho("Reusing tag $tagbase (tagid: $tag_id; page_id: $page_id; node_id: $node_id; edit: ".($edit?"true":"false")."; $note)", "cleanup_tags");
 
 $tags = obj_translate($tag_id, "contenttag", $page_id, "page", $node_id, $edit);
 
 return $tags;
 }
 
 return false;
}

function find_unused_tags($page_id, $used_tags) {
 
 global $DEBUG;
 
 $tags = array();
 $used = array();

 foreach ($used_tags as $name=>$tag) {
 if (is_system_tag($name) || $tag["type"] != "content") continue;
 
 
 $sql = "SELECT count(*) AS c FROM contenttag, page WHERE contenttag.id = ".sqlf_tl_num($tag["id"])." AND contenttag.name = \"".sqlslashes($name)."\" AND contenttag.content_id = page.content_id AND page.id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 
 if ($rs["arr"][0]["c"] > 0) {
 $used[$tag["id"]] = true;
 } 
 }
 
 $sql = "SELECT contenttag.id, contenttag.name, contenttag.unused FROM contenttag, page WHERE contenttag.content_id = page.content_id AND page.id = ".sqlf_tl_num($page_id);
 $rs = query($sql);

 foreach ($rs["arr"] as $tag) {
 if ($used[$tag["id"]]) continue;
 
 
 
 $tags[] = $tag["id"];
 }
 
 return $tags;
}




function find_tag_base($tagname, $page_id = 0) {
 $rs = explode(".", $tagname);

 
 
 if (isset($rs[1]) && ereg("^[A-Z]?[0-9]+$", $rs[1])) {
 $rs[0] .= ".".$rs[1];
 if ($rs[2] == "style") {
 $rs[0] .= ".style";
 }
 }
 return $rs[0];
}




function is_system_tag($tagname) {
 $ppos = strpos($tagname, ".");
 if (!$ppos) return false;
 $tagbase = strtolower(substr($tagbase,0,$ppos));
 return ($tagbase == "seite" || $tagbase == "object" || $tagbase == "ordner" || $tagbase == "node");
}


?>
