<?


function reset_sessionvars() {
 global $click_user, $click_useradmin, $click_folder, $click_group, $click_node;
 $click_user = array();
 $click_useradmin = array();
 $click_folder = array();
 $click_group = array();
 $click_node = array();
}

function get_objectname($col) {
 global $T_USERADMIN, $T_TYPE, $T_USER;

 if ($col["id"] == -1 && $col["type"] == -1) {
 $col["name"] = "";
 $col["object"] = i18n("sum");
 } else if ($col["type"] == $T_USER) {
 $sql = "SELECT firstname, lastname, login FROM systemuser WHERE id = ".sqlf_tl_num($col["id"]);
 $rs = query($sql);
 $col["name"] = $rs["arr"][0]["lastname"]." ".$rs["arr"][0]["firstname"]."<br>(".$rs["arr"][0]["login"].")";
 $col["object"] = $T_TYPE[$col["type"]]["name"];
 } else if ($col["type"] != $T_USERADMIN) {
 $col["name"] = tree_get_name($col["type"],$col["id"]);
 $col["object"] = $T_TYPE[$col["type"]]["name"];
 } else {
 $col["name"] = "";
 $col["object"] = $T_TYPE[$col["type"]]["name"];
 }

 return $col;
}


function get_periodsql($period, $col="time") {
 $sql = "";
 
 if ($period["start"]) {
 $sql .= sqlf_field($col)." >= ".sqlf_tl_num($period["start"]);
 }
 if ($period["end"]) {
 if ($sql) $sql .= " AND ";
 $sql .= sqlf_field($col)." <= ".sqlf_tl_num($period["end"]);
 }

 if (!$sql) $sql = "1 = 1";

 return "($sql)";
}


function get_filtersql($keys, $usercol="user_id", $foldercol="folder_id") {

 $user = "";
 if (is_array($keys["user"])) {
 reset($keys["user"]);
 while (list($key, $val) = each($keys["user"])) {
 if ($user) $user .= ",";
 $user .= sqlf_tl_num($key);
 }
 }
 
 $folder = "";
 if (is_array($keys["folder"])) {
 reset($keys["folder"]);
 while (list($key, $val) = each($keys["folder"])) {
 if ($folder) $folder .= ",";
 $folder .= sqlf_tl_num($key);
 }
 }

 $sql = "";
 if ($usercol && $user) {
 $sql .= sqlf_field($usercol)." IN ($user)";
 }
 if ($foldercol && $folder) {
 if ($sql) $sql .= " OR ";
 $sql .= sqlf_field($foldercol)." IN ($folder)";
 }
 
 if (!$sql) $sql = "1 = 1";

 return "($sql)";
}


function get_keys($type,$id,$rec=0,$keys=array()) {
 global $T_FOLDER, $T_NODE, $T_CONTENT, $T_USER, $T_GROUP, $T_USERADMIN;

 if ($type == $T_FOLDER || $type == $T_NODE) {
 if ($rec) {
 $folder = tree_get_objects($type, $id);
 reset($folder);
 while (list($key,$val) = each($folder)) {
 if ($val["type"] == $T_FOLDER || $val["type"] == $T_NODE) {
 $keys["folder"][$val["id"]] = true;
 }
 }
 }
 $keys["folder"][$id] = true;
 } else if ($type == $T_CONTENT) {
 
 } else if ($type == $T_USER) {
 $keys["user"][$id] = true;
 } else if ($type == $T_GROUP) {
 if ($rec) {
 $groups = tree_get_objects($T_GROUP, $id);
 reset($groups);
 $ids = "";
 while (list($key,$val) = each($groups)) {
 if ($val["type"] == $T_GROUP) {
 if ($ids) $ids .= ",";
 $ids .= sqlf_tl_num($val["id"]);
 }
 }
 if (!$ids) $ids = "0";
 $where = "usergroup_id IN ($ids)";
 } else {
 $where = "usergroup_id = ".sqlf_tl_num($id);
 }
 
 $sql = "SELECT user_id FROM user_group WHERE $where";
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 $keys["user"][$val["user_id"]] = true;
 }
 } else if ($type == $T_USERADMIN) {
 
 $sql = "SELECT id FROM systemuser WHERE active = 1";
 $rs = query($sql);
 while (list($key,$val) = each($rs)) {
 $keys["user"][$val["id"]] = true;
 }
 }

 return $keys;
}

function get_logsql($keys,$period,$logtab="logcmd") {
 global $T_FOLDER, $T_PAGE, $T_TEMPLATE, $T_FILE;
 global $W_CREATE, $W_EDIT, $W_DEL, $W_PAGEPUB, $W_PAGETIME, $W_PAGEQUEUE;

 $periodsql = get_periodsql($period, "$logtab.timestamp");
 $filtersql1 = get_filtersql($keys,"$logtab.user_id","$logtab.o_id");
 $filtersql2 = get_filtersql($keys,"$logtab.user_id","$logtab.o_id2");

 $logtab = sqlf_table($logtab);

 $sql = "$periodsql AND (";

 $sql .= "($filtersql1 AND $logtab.o_type IN (".sqlf_tl_num($T_FOLDER).") AND $logtab.cmd_desc_id IN (".sqlf_tl_num($W_CREATE).",".sqlf_tl_num($W_EDIT).",".sqlf_tl_num($W_DEL).")) OR ";

 $sql .= "($filtersql2 AND $logtab.o_type IN (".sqlf_tl_num($T_PAGE).",".sqlf_tl_num($T_FILE).",".sqlf_tl_num($T_TEMPLATE).") AND $logtab.cmd_desc_id IN (".sqlf_tl_num($W_CREATE).",".sqlf_tl_num($W_EDIT).",".sqlf_tl_num($W_DEL).")) OR ";
 
 $sql .= "($filtersql2 AND $logtab.o_type IN (".sqlf_tl_num($T_PAGE).") AND $logtab.cmd_desc_id IN (".sqlf_tl_num($W_PAGEPUB).",".sqlf_tl_num($W_PAGETIME).",".sqlf_tl_num($W_PAGEQUEUE)."))";

 $sql .= ")";

 return "($sql)";
}


function get_actualstats($keys) {
 
 $stats = array();

 $filtersql = get_filtersql($keys,"creator","folder_id");
 $foldersql = get_filtersql($keys,"creator","id");
 $usersql = get_filtersql($keys,"id","");
 $templatesql = get_filtersql($keys,"template.creator","template_folder.folder_id");

 
 







 $sql = "SELECT count(id) AS c FROM logcmd WHERE $usersql";
 $rs = query($sql);
 $stats["activity"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM systemuser WHERE $usersql AND active = 1 AND id != 1";
 $rs = query($sql);
 $stats["user"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $filtersql";
 $rs = query($sql);
 $stats["pages"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(template.id) AS c FROM template, template_folder WHERE template.id = template_folder.template_id AND $templatesql GROUP BY template.id";
 $rs = query($sql);
 $stats["templates"] = (int) $rs["num"];

 $sql = "SELECT count(id) AS c FROM contentfile WHERE $filtersql AND filetype LIKE \"image/%\"";
 $rs = query($sql);
 $stats["images"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM contentfile WHERE $filtersql AND filetype NOT LIKE \"image/%\"";
 $rs = query($sql);
 $stats["files"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM folder WHERE $foldersql";
 $rs = query($sql);
 $stats["folder"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $filtersql AND (status = 0)";
 $rs = query($sql);
 $stats["pagestatus_edit"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $filtersql AND (status = 1 OR status = 2)";
 $rs = query($sql);
 $stats["pagestatus_pub"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $filtersql AND (status = 3)";
 $rs = query($sql);
 $stats["pagestatus_removed"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $filtersql AND (status = 4)";
 $rs = query($sql);
 $stats["pagestatus_queue"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $filtersql AND (status = 5)";
 $rs = query($sql);
 $stats["pagestatus_time"] = (int) $rs["arr"][0]["c"];

 return $stats;
}


function get_logstats($keys, $period) {
 global $T_PAGE, $T_FOLDER, $T_NODE, $T_USER, $T_GROUP, $T_FILE, $T_IMAGE, $T_TEMPLATE;
 global $W_CREATE, $W_EDIT, $W_DEL, $W_LOGIN, $W_PAGEPUB, $W_PAGEQUEUE, $W_PAGETIME, $W_LOGOUT;

 $stats = array();

 $periodsql = get_periodsql($period, "logcmd.timestamp");
 $filtersql1 = get_filtersql($keys,"user_id","o_id");
 $filtersql2 = get_filtersql($keys,"user_id","o_id2");
 $logsql = get_logsql($keys,$period);

 if ($keys["user"]) {
 $filtersql = get_filtersql($keys,"logcmd.o_id","");
 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_LOGIN)." AND o_type = ".sqlf_tl_num($T_USER);
 $rs = query($sql);
 $stats["logins"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS i, HOUR(FROM_UNIXTIME(timestamp)) AS h FROM logcmd WHERE $filtersql AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_LOGIN)." AND o_type = ".sqlf_tl_num($T_USER)." GROUP BY h ORDER BY i DESC LIMIT 1";
 $rs = query($sql);
 $stats["login_avg"] = (int) round($rs["arr"][0]["h"]).":00";

 $sql = "SELECT count(id) AS i, HOUR(FROM_UNIXTIME(timestamp)) AS h FROM logcmd WHERE $filtersql AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_LOGOUT)." AND o_type = ".sqlf_tl_num($T_USER)." GROUP BY h ORDER BY i DESC LIMIT 1";
 $rs = query($sql);
 $stats["logout_avg"] = (int) round($rs["arr"][0]["h"]).":00";
 
 $sql = "SELECT lo.o_id2 - logcmd.timestamp AS time FROM logcmd, logcmd AS lo 
				WHERE logcmd.cmd_desc_id = ".sqlf_tl_num($W_LOGIN)." AND logcmd.o_type = ".sqlf_tl_num($T_USER)." AND lo.cmd_desc_id = ".sqlf_tl_num($W_LOGOUT)." AND lo.o_type = ".sqlf_tl_num($T_USER)." AND 
				logcmd.info = lo.info AND logcmd.o_id = lo.o_id AND $filtersql AND $periodsql GROUP BY logcmd.timestamp, lo.o_id2";
 $rs = query($sql);
 
 $stats["online"] = 0;
 while (list($key,$val) = each($rs["arr"])) {
 $stats["online"] += $val["time"];
 }
 if ($rs["num"] > 0) $stats["session"] = $stats["online"] / $rs["num"];

 }

 $sql = "SELECT user_id FROM logcmd WHERE $logsql GROUP BY user_id";
 $rs = query($sql);
 $stats["active_user"] = (int) $rs["num"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $logsql";
 $rs = query($sql);
 $stats["activity"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_CREATE)." AND o_type = ".sqlf_tl_num($T_PAGE)." AND info LIKE \"cmd_page_create%\"";
 $rs = query($sql);
 $stats["pages_create"] = (int) $rs["arr"][0]["c"];


 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_EDIT)." AND o_type = ".sqlf_tl_num($T_PAGE)." AND info LIKE \"lock%\"";
 $rs = query($sql);
 $stats["pages_update"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_DEL)." AND o_type = ".sqlf_tl_num($T_PAGE)." AND info LIKE \"cmd_page_del%\"";
 $rs = query($sql);
 $stats["pages_del"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_CREATE)." AND o_type = ".sqlf_tl_num($T_TEMPLATE)." AND info LIKE \"template_create%\"";
 $rs = query($sql);
 $stats["templates_create"] = (int) $rs["arr"][0]["c"];


 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_EDIT)." AND o_type = ".sqlf_tl_num($T_TEMPLATE)." AND info LIKE \"lock%\"";
 $rs = query($sql);
 $stats["templates_edit"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_DEL)." AND o_type = ".sqlf_tl_num($T_TEMPLATE)." AND info LIKE \"template_del%\"";
 $rs = query($sql);
 $stats["templates_del"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_CREATE)." AND o_type = ".sqlf_tl_num($T_FILE);
 $rs = query($sql);
 $stats["files_create"] = (int) $rs["arr"][0]["c"];
 
 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_EDIT)." AND o_type = ".sqlf_tl_num($T_FILE);
 $rs = query($sql);
 $stats["files_edit"] = (int) $rs["arr"][0]["c"];
 
 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_DEL)." AND o_type = ".sqlf_tl_num($T_FILE);
 $rs = query($sql);
 $stats["files_del"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql1 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_CREATE)." AND o_type = ".sqlf_tl_num($T_FOLDER);
 $rs = query($sql);
 $stats["folder_create"] = (int) $rs["arr"][0]["c"];
 
 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql1 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_EDIT)." AND o_type = ".sqlf_tl_num($T_FOLDER);
 $rs = query($sql);
 $stats["folder_edit"] = (int) $rs["arr"][0]["c"];
 
 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql1 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_DEL)." AND o_type = ".sqlf_tl_num($T_FOLDER);
 $rs = query($sql);
 $stats["folder_del"] = (int) $rs["arr"][0]["c"];






 
 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_PAGEPUB)." AND o_type = ".sqlf_tl_num($T_PAGE);
 $rs = query($sql);
 $stats["pages_pub"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_DEL)." AND o_type = ".sqlf_tl_num($T_PAGE)." AND info LIKE \"page_status%\"";
 $rs = query($sql);
 $stats["pages_removed"] = (int) $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $filtersql2 AND $periodsql AND cmd_desc_id = ".sqlf_tl_num($W_PAGEQUEUE)." AND o_type = ".sqlf_tl_num($T_PAGE);
 $rs = query($sql);
 $stats["pages_queue"] = (int) $rs["arr"][0]["c"];







 return $stats;
}


function treenode_number($nid,$ntype) {
 global $T_TYPE, $PERMSQL;
 
 eval("\$sql = \"".$T_TYPE[$ntype]["sql"]."\";");
 $rs = query($sql);
 if ($rs["num"] > 0) while (list($key,$val) = each($rs["arr"])) {
 $n = 0;
 
 
 
 $sql = "SELECT count(id) AS c FROM page WHERE page.folder_id = ".sqlf_tl_num($val["id"]);
 $rs2 = query($sql);
 $n += $rs2["arr"][0]["c"];

 
 $rs["arr"][$key]["stat"] = $n." Seite".(($n != 1)?"n":"");
 }
 return $rs["arr"];
}

function get_userofgroup($nid) {
 global $T_USER;
 if ($nid) {
 $sql = "SELECT systemuser.id, ".sqlf_tl_num($T_USER)." AS type_id, firstname, lastname, login FROM systemuser, user_group WHERE systemuser.id = user_group.user_id AND user_group.usergroup_id = ".sqlf_tl_num($nid)." ORDER BY lastname, firstname";
 } else {
 $users = user_get_visibleusers();
 $sql = "SELECT id, ".sqlf_tl_num($T_USER)." AS type_id, firstname, lastname, login FROM systemuser WHERE active = 1 AND id IN (".implode(",",sqlf_tl_num_array($users)).") ORDER BY lastname, firstname";
 }
 
 $rs = query($sql);
 $rows = array();

 while (list($key,$val) = each($rs["arr"])) {
 $val["name"] = $val["lastname"]." ".$val["firstname"]." (".$val["login"].")";
 $rows[] = $val;
 }

 return $rows;
}


function get_stats($id,$type,$stats) {
 global $W_CREATE, $T_PAGE, $W_EDIT, $T_FOLDER, $T_GROUP, $T_CONTENT, $T_NODE, $USER_ID, $T_USER, $T_FOLDER, $T_FILE, $W_DEL;
 
 
 if ($type == $T_FOLDER || $type == $T_NODE || $type == $T_CONTENT) {
 $where = "folder_id = ".sqlf_tl_num($id);
 $where2 = "o_id2 = ".sqlf_tl_num($id);
 $type = $T_FOLDER;
 }
 if ($type == $T_GROUP) {
 $sql = "SELECT distinct user_id FROM user_group WHERE usergroup_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if (!$rs["arr"]) return $stats;
 while (list($key,$val) = each($rs["arr"])) {
 $ulist[] = $val["user_id"];
 }
 $ulist = implode(",",sqlf_tl_num_array($ulist));
 $where = "editor IN ($ulist)";
 $where2 = "user_id IN ($ulist)";
 }
 if ($type == $T_USER) {
 $where = "editor = ".sqlf_tl_num($id);
 $where2 = "user_id = ".sqlf_tl_num($id);
 }
 if ($id == -1) {
 $where = "folder_id != -1";
 $where2 = "o_id2 != -1";
 }

 
 $sql = "SELECT count(id) AS c FROM page WHERE $where";
 $rs = query($sql);
 $stats["pages"] += $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM page WHERE $where AND (status = 1 OR status = 2)";
 $rs = query($sql);
 $stats["pages_pub"] += $rs["arr"][0]["c"];






 $sql = "SELECT DISTINCT user_id FROM logcmd WHERE $where2";
 
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"]))$stats["user_active_past"][$val["user_id"]] = true;

 $sql = "SELECT count(id) AS c FROM logcmd WHERE $where2 AND cmd_desc_id = ".sqlf_tl_num($W_CREATE)." AND o_type = ".sqlf_tl_num($T_PAGE);
 $rs = query($sql);
 $stats["pages_created"] += $rs["arr"][0]["c"];

 





 $sql = "SELECT count(id) AS c FROM contentfile WHERE $where AND filetype NOT LIKE 'image%'";
 $rs = query($sql);
 $stats["files"] += $rs["arr"][0]["c"];

 $sql = "SELECT count(id) AS c FROM contentfile WHERE $where AND filetype LIKE 'image%'";
 $rs = query($sql);
 $stats["images"] += $rs["arr"][0]["c"];

 






















 $stats["folder"] += 1;









 return $stats;
}

?>
