<?
global $T_PAGE, $T_TEMPLATE, $T_FOLDER, $T_FILE, $T_IMAGE;
define(T_ALLPAGES, "1000".$T_PAGE);
define(T_ALLTEMPLATES, "1000".$T_TEMPLATE);
define(T_ALLFOLDERS, "1000".$T_FOLDER);
define(T_ALLFILES, "1000".$T_FILE);
define(T_ALLIMAGES, "1000".$T_IMAGE);

class MiniBrowserObjectSelector extends BaseObject {
 var $selected = null;
 var $autoselected = null;
 var $excluded = null;
 var $autoexcluded = null;

 
 var $subselected = array();
 
 var $issubselected = false;

 var $selectableTypes = array(T_FOLDER, T_FOLDER_CHANNEL, T_PAGE, T_NODE, T_DOMAIN_CHANNEL, T_CONSTRUCT, T_CONSTRUCT_CATEGORY, T_SOURCE, T_PAGELANGUAGE, T_OBJPROPELEMENT, CT_FILE, T_IMAGE, T_TEMPLATE, T_CONTENTREPOSITORY);

 var $treeUnselectableTypes = array(T_SOURCE, T_PAGELANGUAGE, T_CONTENTREPOSITORIES);

 var $excludableTypes = array(T_CONADMIN, T_CONTENTREPOSITORIES, T_CONTENTREPOSITORY, T_FOLDER, T_FOLDER_CHANNEL, T_PAGE, T_NODE, T_DOMAIN_CHANNEL, T_CONSTRUCT, T_CONSTRUCT_CATEGORY, T_SOURCE, T_PAGELANGUAGE, T_OBJPROP, CT_FILE, T_IMAGE, T_TEMPLATE, T_OBJPROPELEMENT, T_OBJPROPADMIN, T_OBJPROP, T_CONSTRUCTS, T_ALLPAGES, T_ALLFOLDERS, T_ALLTEMPLATES, T_ALLFILES, T_ALLIMAGES);

 var $objects = array(T_FOLDER, T_FOLDER_CHANNEL, T_PAGE, T_NODE, T_DOMAIN_CHANNEL, T_CONSTRUCT, T_CONSTRUCT_CATEGORY, T_SOURCE, T_PAGELANGUAGE, T_OBJPROP, CT_FILE, T_IMAGE, T_TEMPLATE, T_OBJPROPELEMENT, T_CONTENTREPOSITORY);

 var $editable = false;

 var $modified = false;

 function MiniBrowserObjectSelector($editable = true) {
 $this->editable = $editable;
 $this->selected = new ObjectSelectionStore();
 $this->autoselected = new ObjectSelectionStore();
 $this->excluded = new ObjectSelectionStore();
 $this->autoexcluded = new ObjectSelectionStore();
 }

 function getSerializeKey() {
 return array(
 "selected" => node_serialize( $this->selected),
 "autoselected" => node_serialize( $this->autoselected),
 "excluded" => node_serialize( $this->excluded),
 "autoexcluded" => node_serialize( $this->autoexcluded),
 "editable" => node_serialize($this->editable),
 "modified" => node_serialize($this->modified)
 );
 }

 function _normalizeKey( $key ) {
 $key = str_replace(".", "_", $key);
 $pieces = explode("_", $key);
 if ($pieces[0] == T_NODE && false) {
 return T_FOLDER."_".$pieces[1];
 }
 if (!in_array($pieces[0], $this->objects)) {
 return $pieces[0];
 } else {
 return $key;
 }
 }

 function _isSelectable( $key ) {
 $key = str_replace(".", "_", $key);
 $pieces = explode("_", $key);
 return count($pieces) > 1 && in_array($pieces[0], $this->selectableTypes);
 }

 function _isExcludable( $key ) {
 $key = str_replace(".", "_", $key);
 $pieces = explode("_", $key);
 return in_array($pieces[0], $this->excludableTypes);
 }

 function initFromSerializeKey( $key ) {
 $this->selected = node_unserialize( $key["selected"] );
 $this->autoselected = node_unserialize( $key["autoselected"] );
 $this->excluded = node_unserialize( $key["excluded"] );
 $this->autoexcluded = node_unserialize( $key["autoexcluded"] );
 $this->editable = node_unserialize( $key["editable"] );
 $this->modified = node_unserialize( $key["modified"] );
 }

 function subselectFolders() {
 global $FEATURE, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 if ($this->issubselected) {
 
 return;
 }

 $folders = array();
 $inheritedfolders = array();
 if ($FEATURE["multichannelling"]) {
 $fc = new fetchCurl("POST");
 $fc->setUrl($CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/export/selection?sid=$SESSION_TOKEN");
 $postdata = array();
 
 $postdata["pages"] = array_values($this->_getSelectedOrAutoselectedObjects(T_PAGE));
 $postdata["images"] = array_values($this->_getSelectedOrAutoselectedObjects(T_IMAGE));
 $postdata["files"] = array_values($this->_getSelectedOrAutoselectedObjects(CT_FILE));
 $postdata["folders"] = array_values($this->_getSelectedOrAutoselectedObjects(T_FOLDER));
 
 $postdata["inheritedFolders"] = array();
 $inheritedfolders = $this->_getSelectedOrAutoselectedObjects(T_FOLDER_CHANNEL);
 while (list($k, $folder) = each($inheritedfolders)) {
 $folder = explode("_", $folder);
 $channelid = $folder[1];
 $folder = $folder[0];
 if (!$postdata["inheritedFolders"][$channelid]) {
 $postdata["inheritedFolders"][$channelid] = array();
 }
 $postdata["inheritedFolders"][$channelid][] = $folder;
 }
 if (count($postdata["inheritedFolders"]) == 0) {
 unset($postdata["inheritedFolders"]);
 }

 $fc->setHeader("Content-Type", "application/json; charset=utf-8");
 $fc->setPostData(json_encode($postdata));
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $response = json_decode($json, true);
 $inheritedfoldersMap = $response["inheritedFolders"];
 $inheritedfolders = array();
 if (is_array($inheritedfoldersMap)) {
 while (list($channelId, $folders) = each($inheritedfoldersMap)) {
 if (is_array($folders)) {
 while (list ($k, $folder) = each($folders)) {
 $inheritedfolders[] = "${folder}_${channelId}";
 }
 }
 }
 }
 $folders = $response["folders"];
 } else {
 
 $pages = $this->_getSelectedOrAutoselectedObjects(T_PAGE);
 $this->_subselectFolders($pages, T_PAGE, $folders);
 
 $images = $this->_getSelectedOrAutoselectedObjects(T_IMAGE);
 $this->_subselectFolders($images, T_IMAGE, $folders);
 
 $files = $this->_getSelectedOrAutoselectedObjects(CT_FILE);
 $this->_subselectFolders($files, CT_FILE, $folders);
 
 $selfolders = $this->_getSelectedOrAutoselectedObjects(T_FOLDER);
 $this->_subselectFolders($selfolders, T_FOLDER, $folders);
 }
 while (list($k, $folder) = each($folders)) {
 $this->subselected[T_FOLDER."_".$folder] = true;
 }
 while (list($k, $folder) = each($inheritedfolders)) {
 $this->subselected[T_FOLDER_CHANNEL."_".$folder] = true;
 }
 $this->issubselected = true;
 }

 function _getSelectedOrAutoselectedObjects($type) {
 $objects = array();
 if ($this->selected->objectStore[$type]) {
 $objects = array_keys($this->selected->objectStore[$type]);
 }
 if ($this->autoselected->objectStore[$type]) {
 $objects = array_merge($objects, array_keys($this->autoselected->objectStore[$type]));
 }
 if ($this->excluded->objectStore[$type]) {
 $objects = array_diff($objects, array_keys($this->excluded->objectStore[$type]));
 }

 return array_unique($objects);
 }

 function _subselectFolders($ids, $type, &$folders) {
 $id_list = implode(",",$ids);
 if (!$id_list) {
 return;
 }
 $new_folders = array();
 switch($type) {
 case T_PAGE:
 $sql = "select distinct folder_id from page where id in (".implode(",",sqlf_tl_num_array($ids)).")";
 $rs = query($sql);
 while (list ($k, $row) = each($rs["arr"])) {
 $new_folders[] = $row["folder_id"];
 }
 break;
 case T_IMAGE:
 case CT_FILE:
 $sql = "select distinct folder_id from contentfile where id in (".implode(",",sqlf_tl_num_array($ids)).")";
 $rs = query($sql);
 while (list ($k, $row) = each($rs["arr"])) {
 $new_folders[] = $row["folder_id"];
 }
 break;
 case T_FOLDER:
 $sql = "select distinct mother from folder where id in (".implode(",",sqlf_tl_num_array($ids)).")";
 $rs = query($sql);
 while (list ($k, $row) = each($rs["arr"])) {
 if ($row["mother"] != 0) {
 $new_folders[] = $row["mother"];
 }
 }
 break;
 }

 
 $new_folders = array_diff($new_folders, $folders);
 $folders = array_merge($folders, $new_folders);
 $this->_subselectFolders($new_folders, T_FOLDER, $folders);
 }

 function isSelectableType( $type, $tree = false ) {
 $normkey = $this->_normalizeKey($type);
 $retval = in_array($normkey, $this->selectableTypes) && (!$tree || !in_array($normkey, $this->treeUnselectableTypes));
 return $retval;
 }

 function isExcludableType( $type ) {
 return in_array($this->_normalizeKey($type), $this->excludableTypes);
 }

 function select( $key ) {
 if (!$this->editable) {
 return;
 }
 $key = $this->_normalizeKey( $key );
 if (!$this->_isSelectable($key)) {
 return false;
 }
 $this->excluded->unsetKey($key);
 $this->selected->setKey($key);
 $this->setModified();
 return true;
 }

 function autoselect( $key ) {
 $key = $this->_normalizeKey( $key );
 $this->autoselected->setKey($key);
 }

 function unselect( $key ) {
 if (!$this->editable) {
 return;
 }
 $key = $this->_normalizeKey( $key );
 $this->excluded->unsetKey($key);
 $this->selected->unsetKey($key);
 $this->setModified();
 }

 function exclude( $key ) {
 if (!$this->editable) {
 return;
 }
 $key = $this->_normalizeKey( $key );
 if (!$this->_isExcludable( $key ) ) {
 return false;
 }
 $this->selected->unsetKey($key);
 $this->excluded->setKey($key);
 $this->setModified();
 return true;
 }

 function autoexclude( $key ) {
 $key = $this->_normalizeKey( $key );
 $this->autoexcluded->setKey($key);
 }

 function toggle( $key ) {
 if (!$this->editable) {
 return;
 }
 $key = $this->_normalizeKey( $key );
 if ($this->isSelected( $key ) ) {
 if (!$this->exclude( $key ) ) {
 $this->unselect($key);
 }
 $this->exclude( $key );
 } else if ($this->isExcluded( $key ) ) {
 $this->unselect( $key );
 } else {
 if (!$this->select( $key ) ) {
 $this->exclude( $key );
 }
 }
 }

 function isSelected( $key ) {
 $key = $this->_normalizeKey( $key );
 return $this->selected->issetKey($key);
 }
 
 function isAutoSelected( $key ) {
 $key = $this->_normalizeKey( $key );
 return $this->autoselected->issetKey($key);
 }

 function isExcluded( $key ) {
 $key = $this->_normalizeKey( $key );
 return $this->excluded->issetKey($key);
 }
 
 function isAutoExcluded( $key ) {
 $key = $this->_normalizeKey( $key );
 return $this->autoexcluded->issetKey($key);
 }

 function isSubSelected( $key ) {
 $key = $this->_normalizeKey( $key );
 $pieces = explode("_", $key);

 
 switch($pieces[0]) {
 case T_PAGE:
 case CT_FILE:
 case T_IMAGE:
 case T_TEMPLATE:
 case T_SOURCE:
 case T_CONSTRUCT:
 case T_PAGELANGUAGE:
 case T_OBJPROPELEMENT:
 case T_CONTENTREPOSITORY:
 if (count($pieces) > 1) {
 return false;
 }
 break;
 }

 if (array_key_exists( $key, $this->subselected)) {
 return $this->subselected[$key];
 }

 $sel = false;
 switch($pieces[0]) {
 case T_ADMIN:
 $sel = $this->isSubSelected(T_CONADMIN);
 break;
 case T_CONADMIN:
 $sel =
 $this->isSubSelected(T_ALLPAGES) ||
 $this->isSubSelected(T_ALLFILES) ||
 $this->isSubSelected(T_ALLIMAGES) ||
 $this->isSubSelected(T_ALLFOLDERS) ||
 $this->isSubSelected(T_ALLTEMPLATES) ||
 $this->isSubSelected(T_CONSTRUCTS) ||
 $this->isSubSelected(T_OBJPROPADMIN) || 
 $this->isSubSelected(T_CONTENTREPOSITORIES);
 break;
 case T_ALLPAGES:
 $sel = $this->selected->objectStore[T_PAGE] || $this->autoselected->objectStore[T_PAGE];
 break;
 case T_ALLFILES:
 $sel = $this->selected->objectStore[CT_FILE] || $this->autoselected->objectStore[CT_FILE];
 break;
 case T_ALLIMAGES:
 $sel = $this->selected->objectStore[T_IMAGE] || $this->autoselected->objectStore[T_IMAGE];
 break;
 case T_ALLFOLDERS:
 $sel = $this->selected->objectStore[T_FOLDER] || $this->autoselected->objectStore[T_FOLDER];
 break;
 case T_ALLTEMPLATES:
 $sel = $this->selected->objectStore[T_TEMPLATE] || $this->autoselected->objectStore[T_TEMPLATE];
 break;
 case T_OBJPROPADMIN:
 $sel =
 $this->isSubSelected(T_OBJPROP."_".T_PAGE) ||
 $this->isSubSelected(T_OBJPROP."_".T_FOLDER) ||
 $this->isSubSelected(T_OBJPROP."_".T_IMAGE) ||
 $this->isSubSelected(T_OBJPROP."_".CT_FILE) ||
 $this->isSubSelected(T_OBJPROP."_".T_TEMPLATE);
 break;
 case T_OBJPROP:
 
 $objprops = $this->_getSelectedOrAutoselectedObjects(T_OBJPROPELEMENT);
 if (count($objprops) == 0) {
 $sel = false;
 } else {
 $sql = "select count(*) c from objtag where id in (".implode(",",sqlf_tl_num_array($objprops)).") and obj_type = ".sqlf_tl_num($pieces[1]);
 $rs = query($sql);
 $sel = $rs["arr"][0]["c"] > 1;
 }
 break;
 case T_CONSTRUCTS:
 $sel = $this->selected->objectStore[T_CONSTRUCT] || $this->autoselected->objectStore[T_CONSTRUCT];
 break;
 case T_CONTENTREPOSITORIES:
 $sel = $this->selected->objectStore[T_CONTENTREPOSITORY] || $this->autoselected->objectStore[T_CONTENTREPOSITORY];
 break;
 case T_SOURCE:
 $sel = $this->selected->objectStore[T_SOURCE] || $this->autoselected->objectStore[T_SOURCE];
 break;
 case T_PAGELANGUAGE:
 $sel = $this->selected->objectStore[T_PAGELANGUAGE] || $this->autoselected->objectStore[T_PAGELANGUAGE];
 break;
 case T_CONTENT:
 
 $sql = "select folder_id from node";
 $rs = query($sql);
 while (list($k, $row) = each($rs["arr"])) {
 $sel |= $this->isSubSelected(T_NODE."_".$row["folder_id"]);
 if ($sel) {
 break;
 }
 }
 break;
 case T_NODE:
 case T_DOMAIN_CHANNEL:
 $sel = $this->isSubSelected(T_FOLDER."_".$pieces[1]);
 break;
 case T_FOLDER:
 break;
 }

 $this->subselected[$key] = $sel;
 return $sel;
 }

 function getSelectionStatus( $key, $cgId = null ) {
 if (!$key) {
 return "";
 }
 $key = $this->_normalizeKey( $key );
 if ($this->isSelected( $key ) ) {
 $selection = "selected";
 } else if ($this->isExcluded( $key ) ) {
 $selection = "excluded";
 } else if ($this->isAutoExcluded( $key ) ) {
 $selection = "autoexcluded";
 } else if ($this->isAutoSelected($key) ) {
 $selection = "autoselected";
 } else if ($this->isSubSelected($key) ) {
 $selection = "subselected";
 } else {
 $selection = "unselected";
 }

 $pieces = explode("_", $key);
 
 if (($pieces[0] == T_PAGE) && !$cgId) {
 $langvariants = get_language_variants($pieces[1], null, true);
 $foundsel = false;
 $foundex = false;
 $different = false;
 foreach ( $langvariants as $variant ) {
 $varSelStatus = $this->getSelectionStatus(T_PAGE."_$variant", true);
 if ($varSelStatus == "autoselected" || $varSelStatus == "selected") {
 $foundsel = true;
 }
 if ($varSelStatus == "autoexcluded" || $varSelStatus == "excluded") {
 $foundex = true;
 }
 if ($varSelStatus != $selection) {
 $different = true;
 }
 }
 if ($different) {
 $selection = $foundsel ? ($foundex ? "subselected" : "selected") : "unselected";
 }
 }

 return $selection;
 }

 function renderSelection( $key, $cgId = null ) {
 if (!$key) {
 return "";
 }
 global $STAG_PREFIX, $CONTENTGROUPS;
 $key = $this->_normalizeKey( $key );
 $selStatus = $this->getSelectionStatus( $key, $cgId );

 if ($selStatus != "") {
 $title = i18n("export_$selStatus");
 $icon = "$STAG_PREFIX?do=11&module=system&img=check_$selStatus.png";
 if ($cgId) {
 $title = $CONTENTGROUPS[$cgId]["name"] . ' - '.$title;
 $icon = get_langicon( "check_${selStatus}.png", $CONTENTGROUPS[$cgId]["code"], "system" );
 }
 return "<img border=\"0\" src=\"$icon\" alt=\"".$title."\" title=\"".$title."\">";
 } else {
 return "";
 }
 }

 function getSelectionAction( $key ) {
 if (!$key || !$this->editable) {
 return "";
 }
 $key = $this->_normalizeKey( $key );
 if ($this->isSelected( $key ) ) {
 return $this->_isExcludable($key) ? "exclude" : "unselect";
 } else if ($this->isExcluded( $key ) ) {
 return "unselect";
 } else {
 return $this->_isSelectable($key) ? "select" : ($this->_isExcludable($key) ? "exclude" : "");
 }
 }

 function doSelectionAction( $action, $key ) {
 $key = $this->_normalizeKey( $key );
 switch($action) {
 case "select":
 $this->select( $key );
 break;
 case "exclude":
 $this->exclude( $key );
 break;
 case "unselect":
 $this->unselect( $key );
 break;
 }
 }

 function isModified() {
 return $this->modified;
 }

 function setModified($modified = true) {
 $this->modified = $modified;
 }
}

?>
