<?



class NameFormatter extends ResultsetFormatter {
 function format( $row ) {
 $r = $row['readablename'];
 if(!$r) return $row['name'];
 return $r;
 }
}

class IconFormatter extends ResultsetFormatter {
 var $colname;

 function IconFormatter( $colname ) {
 $this->colname = $colname;
 }
 function format( $row ) {
 global $invalid_tags;
 return img( tag_icon( $row[$this->colname] ), 0 );
 }
}

class NodeFormatter extends ResultsetFormatter {
 function format( $row ) {
 $objprop_id = $row['objprop_id'];
 $res = '';
 if($objprop_id) {
 $sql = "SELECT folder.name FROM objprop_node INNER JOIN node ON objprop_node.node_id = node.id INNER JOIN folder ON node.folder_id = folder.id WHERE objprop_node.objprop_id = '".sqlf_escaped($objprop_id)."'";
 $rs = query( $sql );
 $i = 0;
 foreach( $rs['arr'] as $node ) {
 if( $res ) $res .= ', ';
 if( $i++ > 2 ) { $res .= '...'; break; }
 $res .= $node['name'];
 }
 }
 if( $res ) return $res;
 return i18n( 'All' );
 }
}

class ConstructFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $CONSTRUCTS;
 return $CONSTRUCTS[$row['construct_id']];
 }
}

class PermissionFilter extends SQLDatasourceFilter {
 function PermissionFilter() {
 }
 function checkRow( $row ) {
 global $FEATURE, $USER_ID, $T_OBJPROPELEMENT;
 if ( $FEATURE['objtag_perm'] && !perm($USER_ID, $T_OBJPROPELEMENT, $row['id'], 0) ) return false;
 return true;
 }
}
