<?




define("SCHEDULER_STATUS_SUSPENDED", 0);
define("SCHEDULER_STATUS_RUNNING", 1);
define("SCHEDULER_STATUS_SUSPENDING", 2);

define("SCHEDULER_SUSPEND_FILE_NAME", "/../tmp/scheduler.suspend");




class Scheduler {
 




 function suspend($ignoreJobIds=-1) {
 global $USER_ID, $FILEPATH;
 $fp = fopen($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME, "w+");
 fputs($fp, $ignoreJobIds);
 fclose($fp);
 }
 
 



 function getStatus() {
 global $FILEPATH;
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 if (Scheduler::isAnyJobRunning()) {
 return SCHEDULER_STATUS_SUSPENDING;
 } else { 
 return SCHEDULER_STATUS_SUSPENDED;
 }
 } else {
 return SCHEDULER_STATUS_RUNNING;
 }
 }
 
 


 function resume() {
 global $FILEPATH;
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 unlink($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME);
 }
 }
 
 





 function isAnyJobRunning() {
 global $FILEPATH;

 
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 $jobIds = trim(file_get_contents($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)); 
 if (strlen($jobIds) > 0 && $jobIds !== 'undefined') {
 $sqlpart = "WHERE id NOT IN (".sqlf_tl_num_list($jobIds).")";
 }
 }
 
 $res = query("SELECT id FROM job $sqlpart");
 if ($res["num"] == 0) {
 
 return false;
 } else {
 node_class( "sqltable" );
 $jobRunTable = new SqlTable( "jobrun" );
 
 foreach ( $res["arr"] as $job ) {
 $id = $job["id"];
 
 $runs = $jobRunTable->findBy(array("job_id", "valid"), array($id, 1), "=", "starttime DESC", 1);
 if (count($runs) > 0) {
 
 $lastRunRow = $runs[0];
 if ($lastRunRow->getValue("starttime") > 0 && $lastRunRow->getValue("endtime") == 0) {
 
 return true;
 }
 }
 }
 return false;
 }
 }

 






 function allowRun($jobId) {
 global $FILEPATH;
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 $jobIds = trim(file_get_contents($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)); 
 if (strlen($jobIds) > 0) {
 if (in_array($jobId, explode(",", $jobIds))) {
 return true;
 }
 }
 return false;
 } 
 return true;
 }
}
?>